//  (C) Copyright Dave Abrahams, Steve Cleary, Beman Dawes, Howard
//  Hinnant & John Maddock 2000.  
//  Use, modification and distribution are subject to the Boost Software License,
//  Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
//  http://www.boost.org/LICENSE_1_0.txt).
//
//  See http://www.boost.org/libs/type_traits for most recent version including documentation.
//
//  defines traits classes for cv-qualified types:
//  is_const, is_volatile, remove_const, remove_volatile, remove_cv.

#ifndef SOFA_PBRPC_BOOST_TT_CV_TRAITS_HPP_INCLUDED
#define SOFA_PBRPC_BOOST_TT_CV_TRAITS_HPP_INCLUDED

#include <sofa/pbrpc/boost/type_traits/add_const.hpp>
#include <sofa/pbrpc/boost/type_traits/add_volatile.hpp>
#include <sofa/pbrpc/boost/type_traits/add_cv.hpp>
#include <sofa/pbrpc/boost/type_traits/is_const.hpp>
#include <sofa/pbrpc/boost/type_traits/is_volatile.hpp>
#include <sofa/pbrpc/boost/type_traits/remove_const.hpp>
#include <sofa/pbrpc/boost/type_traits/remove_volatile.hpp>
#include <sofa/pbrpc/boost/type_traits/remove_cv.hpp>

#endif // SOFA_PBRPC_BOOST_TT_CV_TRAITS_HPP_INCLUDED
